%%%===================================================%%%
%%% 		Bus Driving JavaScript Interface   		%%%
%%%									%%%
%%%									%%%
%%% (C) Zhisheng Huangn 2003					%%%
%%%===================================================%%%

:-object busDrivingjsi.
 
main :-
	setInitialValues(bus1),
	new(busDrivinglistener(script, queue), _),
	new(busDrivinglistener(script, queue2), _),
	true.	

setInitialValues(Object):-
	set_field(Object, speed, 0),
	set_field(Object, engine_status, off).

:-end_object busDrivingjsi.


:-object busDrivinglistener : [jsilib, bcilib, busDriving].


     busDrivinglistener(Node, Queue) :-
		run(Node, Queue).

	run(Node, Queue) :-
		repeat,
			get_queue(Node, Queue, Term),
%			format('processing ~w~n', [Term]),
			process_test_term(Term),
		Term = stop,
		!.

	process_test_term(Term):-
		Term = setRotation(Object,X,Y,Z,R),
		!,
		setRotation(Object, X,Y,Z,R),
		true.

	
	process_test_term(Term):-
		Term = engine(Object,Status),
		!,
		setEngineColor(Object, Status),
		setEngineSound(Object, Status),
		drive(Object),
		true.

	process_test_term(Term):-
		Term = speedChange(Object,Change),
		!,
		speedChange(Object, Change),
		setSpeedChangeSound(Object, Change),
		true.






	process_test_term(Term):-
		!,
		format('Unknown command:~w!~n',[Term]),
		true.


:-end_object busDrivinglistener.

:-object busDriving : [bcilib, jsilib].

var gaschange= -0.1.
var sleeptime = 150.

setEngineColor(Object, on):-
		!,
		setSFColor(Object, engineColor, 0, 1, 0).

setEngineColor(Object, off):-
		!,
		setSFColor(Object, engineColor, 1, 0, 0).

setEngineSound(Object, on):-
		!,
		setSFBool(Object,audioLoop,true),
		setMFString(Object, audioURL, ['./audio/engineOn.wav']),
		true.

setEngineSound(Object, off):-
		!,
		setSFBool(Object,audioLoop,false).

setSpeedChangeSound(Object, Change):-
		Change > 0,
		!,
		setSFBool(Object,audioLoop,true),
		setMFString(Object, audioURL, ['./audio/gas.wav']),
		sleep(500),
		setEngineSound(Object,on),
		true.

setSpeedChangeSound(Object, Change):-
		Change < 0,
		!,
		setSFBool(Object,audioLoop,true),
		setMFString(Object, audioURL, ['./audio/brake.wav']),
		sleep(300),
		setEngineSound(Object,on),
		true.


setSpeedChangeSound(_,_).


drive(Object):-
	get_field(Object, engine_status, Status),
      Status = off,
	!,
	Speed = 0,
	set_field(Object, speed, Speed),
	showSpeed(Object, Speed),
	true.


drive(Object):-
	getRotation(Object, _X2, _Y2, _Z2, R2), 
	getPosition(Object,X, Y ,Z),
	get_field(Object, speed, Speed),
	Xdif is Speed * cos(R2),
	Zdif is Speed * sin(R2),
	Xnew is X + Xdif,
	Znew is Z - Zdif,
	setPosition(Object, Xnew, Y, Znew),
	speedChange(Object,gaschange),
	sleep(sleeptime),
	drive(Object).


speedChange(Object, Change):-
		get_field(Object, engine_status, Status),
		Status = on,
		get_field(Object, speed, Speed),
		Speednew is Speed + Change,
		Speednew > 0,
		!,
		set_field(Object, speed, Speednew),
		showSpeed(Object, Speednew).

speedChange(_,_).

showSpeed(Object, Speed):-
		get_window(Window),
		call(Window, showSpeed, [Object, Speed],_).



:-end_object busDriving.
